package mezz.jei.common.network.packets;

import mezz.jei.common.network.IPacketId;
import mezz.jei.common.network.PacketIdServer;
import mezz.jei.common.network.ServerPacketContext;
import mezz.jei.common.network.ServerPacketData;
import mezz.jei.core.config.GiveMode;
import mezz.jei.common.util.ServerCommandUtil;
import net.minecraft.class_1799;
import net.minecraft.class_2540;
import net.minecraft.class_3222;
import net.minecraft.server.MinecraftServer;
import java.util.concurrent.CompletableFuture;

public class PacketGiveItemStack extends PacketJei {
	private final class_1799 itemStack;
	private final GiveMode giveMode;

	public PacketGiveItemStack(class_1799 itemStack, GiveMode giveMode) {
		this.itemStack = itemStack;
		this.giveMode = giveMode;
	}

	@Override
	public IPacketId getPacketId() {
		return PacketIdServer.GIVE_ITEM;
	}

	@Override
	public void writePacketData(class_2540 buf) {
		buf.method_10793(itemStack);
		buf.method_10817(giveMode);
	}

	public static CompletableFuture<Void> readPacketData(ServerPacketData data) {
		class_2540 buf = data.buf();
		class_1799 itemStack = buf.method_10819();
		GiveMode giveMode = buf.method_10818(GiveMode.class);
		ServerPacketContext context = data.context();
		class_3222 player = context.player();
		MinecraftServer server = player.field_13995;
		return server.method_20493(() -> ServerCommandUtil.executeGive(context, itemStack, giveMode));
	}
}
